# Copyright 2009 Mel Wilson
# This file is part of SysvIpcMsg.

# SysvIpcMsg is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# SysvIpcMsg is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with SysvIpcMsg.  If not, see <http://www.gnu.org/licenses/>.
'''
$Id$'''
import _sysvipcmsg
from _sysvipcmsg import IPC_CREAT, IPC_NOWAIT, MSG_EXCEPT, MSG_NOERROR

class IPCQueue:
	def __init__ (self, msgkey=-1, flags=0):
		self.flags = flags
		self.qid = _sysvipcmsg.msgget (msgkey, flags)
	
	def recv (self, length, msgtype=1, flags=None):
		if flags is None:
			flags = self.flags
		return _sysvipcmsg.msgrcv (self.qid, length, msgtype, flags)
		
	def send (self, text, msgtype=1, flags=None):
		if flags is None:
			flags = self.flags
		return _sysvipcmsg.msgsnd (self.qid, text, msgtype, flags)
